// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_client

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ProfileClient is the client API for Profile service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ProfileClient interface {
	//Получить список всех привязанных номеров
	ListPhones(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_ListPhonesClient, error)
	//Привязать к профилю номер из подтверждающего токена
	LinkPhone(ctx context.Context, in *PhoneToken, opts ...grpc.CallOption) (*api.Empty, error)
	//Отвязать номер из профиля
	UnlinkPhone(ctx context.Context, in *api.PhoneNumber, opts ...grpc.CallOption) (*api.Empty, error)
	//Привязать к профилю pushID
	LinkPushId(ctx context.Context, in *api.PushId, opts ...grpc.CallOption) (*api.Empty, error)
	//Отвязать pushID от профиля
	UnLinkPushId(ctx context.Context, in *api.PushId, opts ...grpc.CallOption) (*api.Empty, error)
	//Получить или мониторить pushID на профиле
	ListPushId(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_ListPushIdClient, error)
	//создать или обновить учетную запись для интеграции с внешними сервисами от имени клиента и получить ее параметрв
	//время жизни учетки 5 минут, ее необходимо продлять повторными вызовами этого метода передавая в качестве параметра первоначальный ответ
	UpdateAccessCredentials(ctx context.Context, in *AccessCredentials, opts ...grpc.CallOption) (*AccessCredentials, error)
	ListAccessCredentials(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_ListAccessCredentialsClient, error)
	RevokeAccessCredentials(ctx context.Context, in *AccessCredentials, opts ...grpc.CallOption) (*AccessCredentials, error)
	//Запрашивает текущий профиль пользователя и продолжает его мониторить
	Self(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_SelfClient, error)
	//
	// Получить отчет по финансовым операциям
	BuildFinanceReport(ctx context.Context, in *api.ReportRequestOptions, opts ...grpc.CallOption) (Profile_BuildFinanceReportClient, error)
	SetName(ctx context.Context, in *AccountProfile, opts ...grpc.CallOption) (*AccountProfile, error)
	// Получает и мониторит список документов у пользователя (поле data в этом случае не передается)
	GetProfileDocuments(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_GetProfileDocumentsClient, error)
	// Получает информацию по документу с заданными id
	GetProfileDocument(ctx context.Context, in *ProfileDocument, opts ...grpc.CallOption) (*ProfileDocument, error)
	// Добавляет (если id не указан) или обновляет информацию по документу
	UpdateProfileDocument(ctx context.Context, in *ProfileDocument, opts ...grpc.CallOption) (*ProfileDocument, error)
	// Удаляет документ с заданным id
	DeleteProfileDocument(ctx context.Context, in *ProfileDocument, opts ...grpc.CallOption) (*ProfileDocument, error)
	// Обновление данных о согласии пользователя на работу с сервисом
	AcceptAgreement(ctx context.Context, in *api.AccountAgreement, opts ...grpc.CallOption) (*api.AccountAgreement, error)
	// Получает и значение действеющих горанийений по тарифу
	GetLimits(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_GetLimitsClient, error)
	// Подписывает профиль на заданную очередь с уведомлениями (сейчас поддерживаются изменения профиля и смс)
	Subscribe(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (*api.Subscription, error)
	// Отписывает профиль от заданной очереди уведомлений
	Unsubscribe(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (*api.Subscription, error)
}

type profileClient struct {
	cc grpc.ClientConnInterface
}

func NewProfileClient(cc grpc.ClientConnInterface) ProfileClient {
	return &profileClient{cc}
}

func (c *profileClient) ListPhones(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_ListPhonesClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[0], "/com.freeje.api.client.Profile/ListPhones", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileListPhonesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_ListPhonesClient interface {
	Recv() (*api.PhoneNumber, error)
	grpc.ClientStream
}

type profileListPhonesClient struct {
	grpc.ClientStream
}

func (x *profileListPhonesClient) Recv() (*api.PhoneNumber, error) {
	m := new(api.PhoneNumber)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *profileClient) LinkPhone(ctx context.Context, in *PhoneToken, opts ...grpc.CallOption) (*api.Empty, error) {
	out := new(api.Empty)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/LinkPhone", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) UnlinkPhone(ctx context.Context, in *api.PhoneNumber, opts ...grpc.CallOption) (*api.Empty, error) {
	out := new(api.Empty)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/UnlinkPhone", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) LinkPushId(ctx context.Context, in *api.PushId, opts ...grpc.CallOption) (*api.Empty, error) {
	out := new(api.Empty)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/LinkPushId", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) UnLinkPushId(ctx context.Context, in *api.PushId, opts ...grpc.CallOption) (*api.Empty, error) {
	out := new(api.Empty)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/UnLinkPushId", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) ListPushId(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_ListPushIdClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[1], "/com.freeje.api.client.Profile/ListPushId", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileListPushIdClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_ListPushIdClient interface {
	Recv() (*api.PushId, error)
	grpc.ClientStream
}

type profileListPushIdClient struct {
	grpc.ClientStream
}

func (x *profileListPushIdClient) Recv() (*api.PushId, error) {
	m := new(api.PushId)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *profileClient) UpdateAccessCredentials(ctx context.Context, in *AccessCredentials, opts ...grpc.CallOption) (*AccessCredentials, error) {
	out := new(AccessCredentials)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/UpdateAccessCredentials", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) ListAccessCredentials(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_ListAccessCredentialsClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[2], "/com.freeje.api.client.Profile/ListAccessCredentials", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileListAccessCredentialsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_ListAccessCredentialsClient interface {
	Recv() (*AccessCredentials, error)
	grpc.ClientStream
}

type profileListAccessCredentialsClient struct {
	grpc.ClientStream
}

func (x *profileListAccessCredentialsClient) Recv() (*AccessCredentials, error) {
	m := new(AccessCredentials)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *profileClient) RevokeAccessCredentials(ctx context.Context, in *AccessCredentials, opts ...grpc.CallOption) (*AccessCredentials, error) {
	out := new(AccessCredentials)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/RevokeAccessCredentials", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) Self(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_SelfClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[3], "/com.freeje.api.client.Profile/Self", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileSelfClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_SelfClient interface {
	Recv() (*AccountProfile, error)
	grpc.ClientStream
}

type profileSelfClient struct {
	grpc.ClientStream
}

func (x *profileSelfClient) Recv() (*AccountProfile, error) {
	m := new(AccountProfile)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *profileClient) BuildFinanceReport(ctx context.Context, in *api.ReportRequestOptions, opts ...grpc.CallOption) (Profile_BuildFinanceReportClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[4], "/com.freeje.api.client.Profile/BuildFinanceReport", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileBuildFinanceReportClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_BuildFinanceReportClient interface {
	Recv() (*api.FinanceOperation, error)
	grpc.ClientStream
}

type profileBuildFinanceReportClient struct {
	grpc.ClientStream
}

func (x *profileBuildFinanceReportClient) Recv() (*api.FinanceOperation, error) {
	m := new(api.FinanceOperation)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *profileClient) SetName(ctx context.Context, in *AccountProfile, opts ...grpc.CallOption) (*AccountProfile, error) {
	out := new(AccountProfile)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/SetName", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) GetProfileDocuments(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_GetProfileDocumentsClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[5], "/com.freeje.api.client.Profile/GetProfileDocuments", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileGetProfileDocumentsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_GetProfileDocumentsClient interface {
	Recv() (*ProfileDocument, error)
	grpc.ClientStream
}

type profileGetProfileDocumentsClient struct {
	grpc.ClientStream
}

func (x *profileGetProfileDocumentsClient) Recv() (*ProfileDocument, error) {
	m := new(ProfileDocument)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *profileClient) GetProfileDocument(ctx context.Context, in *ProfileDocument, opts ...grpc.CallOption) (*ProfileDocument, error) {
	out := new(ProfileDocument)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/GetProfileDocument", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) UpdateProfileDocument(ctx context.Context, in *ProfileDocument, opts ...grpc.CallOption) (*ProfileDocument, error) {
	out := new(ProfileDocument)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/UpdateProfileDocument", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) DeleteProfileDocument(ctx context.Context, in *ProfileDocument, opts ...grpc.CallOption) (*ProfileDocument, error) {
	out := new(ProfileDocument)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/DeleteProfileDocument", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) AcceptAgreement(ctx context.Context, in *api.AccountAgreement, opts ...grpc.CallOption) (*api.AccountAgreement, error) {
	out := new(api.AccountAgreement)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/AcceptAgreement", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) GetLimits(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Profile_GetLimitsClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[6], "/com.freeje.api.client.Profile/GetLimits", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileGetLimitsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_GetLimitsClient interface {
	Recv() (*Limit, error)
	grpc.ClientStream
}

type profileGetLimitsClient struct {
	grpc.ClientStream
}

func (x *profileGetLimitsClient) Recv() (*Limit, error) {
	m := new(Limit)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *profileClient) Subscribe(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (*api.Subscription, error) {
	out := new(api.Subscription)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/Subscribe", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) Unsubscribe(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (*api.Subscription, error) {
	out := new(api.Subscription)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Profile/Unsubscribe", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ProfileServer is the server API for Profile service.
// All implementations should embed UnimplementedProfileServer
// for forward compatibility
type ProfileServer interface {
	//Получить список всех привязанных номеров
	ListPhones(*api.RequestMode, Profile_ListPhonesServer) error
	//Привязать к профилю номер из подтверждающего токена
	LinkPhone(context.Context, *PhoneToken) (*api.Empty, error)
	//Отвязать номер из профиля
	UnlinkPhone(context.Context, *api.PhoneNumber) (*api.Empty, error)
	//Привязать к профилю pushID
	LinkPushId(context.Context, *api.PushId) (*api.Empty, error)
	//Отвязать pushID от профиля
	UnLinkPushId(context.Context, *api.PushId) (*api.Empty, error)
	//Получить или мониторить pushID на профиле
	ListPushId(*api.RequestMode, Profile_ListPushIdServer) error
	//создать или обновить учетную запись для интеграции с внешними сервисами от имени клиента и получить ее параметрв
	//время жизни учетки 5 минут, ее необходимо продлять повторными вызовами этого метода передавая в качестве параметра первоначальный ответ
	UpdateAccessCredentials(context.Context, *AccessCredentials) (*AccessCredentials, error)
	ListAccessCredentials(*api.RequestMode, Profile_ListAccessCredentialsServer) error
	RevokeAccessCredentials(context.Context, *AccessCredentials) (*AccessCredentials, error)
	//Запрашивает текущий профиль пользователя и продолжает его мониторить
	Self(*api.RequestMode, Profile_SelfServer) error
	//
	// Получить отчет по финансовым операциям
	BuildFinanceReport(*api.ReportRequestOptions, Profile_BuildFinanceReportServer) error
	SetName(context.Context, *AccountProfile) (*AccountProfile, error)
	// Получает и мониторит список документов у пользователя (поле data в этом случае не передается)
	GetProfileDocuments(*api.RequestMode, Profile_GetProfileDocumentsServer) error
	// Получает информацию по документу с заданными id
	GetProfileDocument(context.Context, *ProfileDocument) (*ProfileDocument, error)
	// Добавляет (если id не указан) или обновляет информацию по документу
	UpdateProfileDocument(context.Context, *ProfileDocument) (*ProfileDocument, error)
	// Удаляет документ с заданным id
	DeleteProfileDocument(context.Context, *ProfileDocument) (*ProfileDocument, error)
	// Обновление данных о согласии пользователя на работу с сервисом
	AcceptAgreement(context.Context, *api.AccountAgreement) (*api.AccountAgreement, error)
	// Получает и значение действеющих горанийений по тарифу
	GetLimits(*api.RequestMode, Profile_GetLimitsServer) error
	// Подписывает профиль на заданную очередь с уведомлениями (сейчас поддерживаются изменения профиля и смс)
	Subscribe(context.Context, *api.Subscription) (*api.Subscription, error)
	// Отписывает профиль от заданной очереди уведомлений
	Unsubscribe(context.Context, *api.Subscription) (*api.Subscription, error)
}

// UnimplementedProfileServer should be embedded to have forward compatible implementations.
type UnimplementedProfileServer struct {
}

func (UnimplementedProfileServer) ListPhones(*api.RequestMode, Profile_ListPhonesServer) error {
	return status.Errorf(codes.Unimplemented, "method ListPhones not implemented")
}
func (UnimplementedProfileServer) LinkPhone(context.Context, *PhoneToken) (*api.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method LinkPhone not implemented")
}
func (UnimplementedProfileServer) UnlinkPhone(context.Context, *api.PhoneNumber) (*api.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UnlinkPhone not implemented")
}
func (UnimplementedProfileServer) LinkPushId(context.Context, *api.PushId) (*api.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method LinkPushId not implemented")
}
func (UnimplementedProfileServer) UnLinkPushId(context.Context, *api.PushId) (*api.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UnLinkPushId not implemented")
}
func (UnimplementedProfileServer) ListPushId(*api.RequestMode, Profile_ListPushIdServer) error {
	return status.Errorf(codes.Unimplemented, "method ListPushId not implemented")
}
func (UnimplementedProfileServer) UpdateAccessCredentials(context.Context, *AccessCredentials) (*AccessCredentials, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateAccessCredentials not implemented")
}
func (UnimplementedProfileServer) ListAccessCredentials(*api.RequestMode, Profile_ListAccessCredentialsServer) error {
	return status.Errorf(codes.Unimplemented, "method ListAccessCredentials not implemented")
}
func (UnimplementedProfileServer) RevokeAccessCredentials(context.Context, *AccessCredentials) (*AccessCredentials, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RevokeAccessCredentials not implemented")
}
func (UnimplementedProfileServer) Self(*api.RequestMode, Profile_SelfServer) error {
	return status.Errorf(codes.Unimplemented, "method Self not implemented")
}
func (UnimplementedProfileServer) BuildFinanceReport(*api.ReportRequestOptions, Profile_BuildFinanceReportServer) error {
	return status.Errorf(codes.Unimplemented, "method BuildFinanceReport not implemented")
}
func (UnimplementedProfileServer) SetName(context.Context, *AccountProfile) (*AccountProfile, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetName not implemented")
}
func (UnimplementedProfileServer) GetProfileDocuments(*api.RequestMode, Profile_GetProfileDocumentsServer) error {
	return status.Errorf(codes.Unimplemented, "method GetProfileDocuments not implemented")
}
func (UnimplementedProfileServer) GetProfileDocument(context.Context, *ProfileDocument) (*ProfileDocument, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetProfileDocument not implemented")
}
func (UnimplementedProfileServer) UpdateProfileDocument(context.Context, *ProfileDocument) (*ProfileDocument, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateProfileDocument not implemented")
}
func (UnimplementedProfileServer) DeleteProfileDocument(context.Context, *ProfileDocument) (*ProfileDocument, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteProfileDocument not implemented")
}
func (UnimplementedProfileServer) AcceptAgreement(context.Context, *api.AccountAgreement) (*api.AccountAgreement, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AcceptAgreement not implemented")
}
func (UnimplementedProfileServer) GetLimits(*api.RequestMode, Profile_GetLimitsServer) error {
	return status.Errorf(codes.Unimplemented, "method GetLimits not implemented")
}
func (UnimplementedProfileServer) Subscribe(context.Context, *api.Subscription) (*api.Subscription, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Subscribe not implemented")
}
func (UnimplementedProfileServer) Unsubscribe(context.Context, *api.Subscription) (*api.Subscription, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Unsubscribe not implemented")
}

// UnsafeProfileServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ProfileServer will
// result in compilation errors.
type UnsafeProfileServer interface {
	mustEmbedUnimplementedProfileServer()
}

func RegisterProfileServer(s grpc.ServiceRegistrar, srv ProfileServer) {
	s.RegisterService(&Profile_ServiceDesc, srv)
}

func _Profile_ListPhones_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).ListPhones(m, &profileListPhonesServer{stream})
}

type Profile_ListPhonesServer interface {
	Send(*api.PhoneNumber) error
	grpc.ServerStream
}

type profileListPhonesServer struct {
	grpc.ServerStream
}

func (x *profileListPhonesServer) Send(m *api.PhoneNumber) error {
	return x.ServerStream.SendMsg(m)
}

func _Profile_LinkPhone_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PhoneToken)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).LinkPhone(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/LinkPhone",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).LinkPhone(ctx, req.(*PhoneToken))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_UnlinkPhone_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.PhoneNumber)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).UnlinkPhone(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/UnlinkPhone",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).UnlinkPhone(ctx, req.(*api.PhoneNumber))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_LinkPushId_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.PushId)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).LinkPushId(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/LinkPushId",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).LinkPushId(ctx, req.(*api.PushId))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_UnLinkPushId_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.PushId)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).UnLinkPushId(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/UnLinkPushId",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).UnLinkPushId(ctx, req.(*api.PushId))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_ListPushId_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).ListPushId(m, &profileListPushIdServer{stream})
}

type Profile_ListPushIdServer interface {
	Send(*api.PushId) error
	grpc.ServerStream
}

type profileListPushIdServer struct {
	grpc.ServerStream
}

func (x *profileListPushIdServer) Send(m *api.PushId) error {
	return x.ServerStream.SendMsg(m)
}

func _Profile_UpdateAccessCredentials_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AccessCredentials)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).UpdateAccessCredentials(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/UpdateAccessCredentials",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).UpdateAccessCredentials(ctx, req.(*AccessCredentials))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_ListAccessCredentials_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).ListAccessCredentials(m, &profileListAccessCredentialsServer{stream})
}

type Profile_ListAccessCredentialsServer interface {
	Send(*AccessCredentials) error
	grpc.ServerStream
}

type profileListAccessCredentialsServer struct {
	grpc.ServerStream
}

func (x *profileListAccessCredentialsServer) Send(m *AccessCredentials) error {
	return x.ServerStream.SendMsg(m)
}

func _Profile_RevokeAccessCredentials_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AccessCredentials)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).RevokeAccessCredentials(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/RevokeAccessCredentials",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).RevokeAccessCredentials(ctx, req.(*AccessCredentials))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_Self_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).Self(m, &profileSelfServer{stream})
}

type Profile_SelfServer interface {
	Send(*AccountProfile) error
	grpc.ServerStream
}

type profileSelfServer struct {
	grpc.ServerStream
}

func (x *profileSelfServer) Send(m *AccountProfile) error {
	return x.ServerStream.SendMsg(m)
}

func _Profile_BuildFinanceReport_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.ReportRequestOptions)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).BuildFinanceReport(m, &profileBuildFinanceReportServer{stream})
}

type Profile_BuildFinanceReportServer interface {
	Send(*api.FinanceOperation) error
	grpc.ServerStream
}

type profileBuildFinanceReportServer struct {
	grpc.ServerStream
}

func (x *profileBuildFinanceReportServer) Send(m *api.FinanceOperation) error {
	return x.ServerStream.SendMsg(m)
}

func _Profile_SetName_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AccountProfile)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).SetName(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/SetName",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).SetName(ctx, req.(*AccountProfile))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_GetProfileDocuments_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).GetProfileDocuments(m, &profileGetProfileDocumentsServer{stream})
}

type Profile_GetProfileDocumentsServer interface {
	Send(*ProfileDocument) error
	grpc.ServerStream
}

type profileGetProfileDocumentsServer struct {
	grpc.ServerStream
}

func (x *profileGetProfileDocumentsServer) Send(m *ProfileDocument) error {
	return x.ServerStream.SendMsg(m)
}

func _Profile_GetProfileDocument_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ProfileDocument)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).GetProfileDocument(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/GetProfileDocument",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).GetProfileDocument(ctx, req.(*ProfileDocument))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_UpdateProfileDocument_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ProfileDocument)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).UpdateProfileDocument(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/UpdateProfileDocument",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).UpdateProfileDocument(ctx, req.(*ProfileDocument))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_DeleteProfileDocument_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ProfileDocument)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).DeleteProfileDocument(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/DeleteProfileDocument",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).DeleteProfileDocument(ctx, req.(*ProfileDocument))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_AcceptAgreement_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.AccountAgreement)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).AcceptAgreement(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/AcceptAgreement",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).AcceptAgreement(ctx, req.(*api.AccountAgreement))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_GetLimits_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).GetLimits(m, &profileGetLimitsServer{stream})
}

type Profile_GetLimitsServer interface {
	Send(*Limit) error
	grpc.ServerStream
}

type profileGetLimitsServer struct {
	grpc.ServerStream
}

func (x *profileGetLimitsServer) Send(m *Limit) error {
	return x.ServerStream.SendMsg(m)
}

func _Profile_Subscribe_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.Subscription)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).Subscribe(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/Subscribe",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).Subscribe(ctx, req.(*api.Subscription))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_Unsubscribe_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.Subscription)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).Unsubscribe(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Profile/Unsubscribe",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).Unsubscribe(ctx, req.(*api.Subscription))
	}
	return interceptor(ctx, in, info, handler)
}

// Profile_ServiceDesc is the grpc.ServiceDesc for Profile service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Profile_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.client.Profile",
	HandlerType: (*ProfileServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "LinkPhone",
			Handler:    _Profile_LinkPhone_Handler,
		},
		{
			MethodName: "UnlinkPhone",
			Handler:    _Profile_UnlinkPhone_Handler,
		},
		{
			MethodName: "LinkPushId",
			Handler:    _Profile_LinkPushId_Handler,
		},
		{
			MethodName: "UnLinkPushId",
			Handler:    _Profile_UnLinkPushId_Handler,
		},
		{
			MethodName: "UpdateAccessCredentials",
			Handler:    _Profile_UpdateAccessCredentials_Handler,
		},
		{
			MethodName: "RevokeAccessCredentials",
			Handler:    _Profile_RevokeAccessCredentials_Handler,
		},
		{
			MethodName: "SetName",
			Handler:    _Profile_SetName_Handler,
		},
		{
			MethodName: "GetProfileDocument",
			Handler:    _Profile_GetProfileDocument_Handler,
		},
		{
			MethodName: "UpdateProfileDocument",
			Handler:    _Profile_UpdateProfileDocument_Handler,
		},
		{
			MethodName: "DeleteProfileDocument",
			Handler:    _Profile_DeleteProfileDocument_Handler,
		},
		{
			MethodName: "AcceptAgreement",
			Handler:    _Profile_AcceptAgreement_Handler,
		},
		{
			MethodName: "Subscribe",
			Handler:    _Profile_Subscribe_Handler,
		},
		{
			MethodName: "Unsubscribe",
			Handler:    _Profile_Unsubscribe_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "ListPhones",
			Handler:       _Profile_ListPhones_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "ListPushId",
			Handler:       _Profile_ListPushId_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "ListAccessCredentials",
			Handler:       _Profile_ListAccessCredentials_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "Self",
			Handler:       _Profile_Self_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "BuildFinanceReport",
			Handler:       _Profile_BuildFinanceReport_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetProfileDocuments",
			Handler:       _Profile_GetProfileDocuments_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetLimits",
			Handler:       _Profile_GetLimits_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "client/profile.proto",
}
